package bicliqueviz;

import javax.swing.JFrame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Font;

public class HistogramBiWin extends JFrame
{
	static final long serialVersionUID = 548743l;
	private final int RECT_SIDE = 30;
	private final int Y_OFFSET = 20;
	private float MAX_VALUE = 100.0f;

	public HistogramBiWin() 
	{
		super();
		
		setTitle("Biclique histogram");
		setSize(600, 550);
		setLocationRelativeTo(null);
		
		MAX_VALUE = BiCliqueWin.maxHistogramValue;
		
		setVisible(true);
	}
	
	public void paint(Graphics g)
	{
		Graphics2D g2d = (Graphics2D)g;
		super.paint(g);
		
		for(int i = 0; i < 15; i++)
		{
			for(int j = 0; j < 15; j++)
			{
				float count = BiCliqueWin.histogramMatrix[j][i];
				
				float percentage = count/MAX_VALUE;
				
				if(percentage > 1.0f)
				{
					percentage = 1.0f;
				}
				
				int colour_value = (int)(percentage*255.0f);
				
				Color c = new Color(colour_value,0,255-colour_value);
				
				g2d.setColor(c);
				
				g2d.fillRect((i+1)*RECT_SIDE, (j+1)*RECT_SIDE+Y_OFFSET, RECT_SIDE, RECT_SIDE);
				g2d.setColor(Color.BLACK);
				g2d.setFont(new Font("Default", Font.PLAIN, 10));
				g2d.drawString(BiCliqueWin.histogramMatrix[j][i]+"", (i+1)*RECT_SIDE+5, (j+1)*RECT_SIDE+Y_OFFSET+15);
			}
		}
		
		g2d.setFont(new Font("Default", Font.PLAIN, 10));
		for(int a = 0; a < 15; a++)
		{
			g2d.setColor(Color.BLACK);
			g2d.drawString((a+1)+"", (a*RECT_SIDE+RECT_SIDE/2-5)+RECT_SIDE, 40);
		}
		
		for(int b = 0; b < 15; b++)
		{
			g2d.setColor(Color.BLACK);
			g2d.drawString((b+1)+"", 10, (b*RECT_SIDE+RECT_SIDE/2+5)+Y_OFFSET+RECT_SIDE);
		}
		
		g2d.drawLine(0, Y_OFFSET, RECT_SIDE, RECT_SIDE+Y_OFFSET);
		g2d.drawString("a", 20,35);
		g2d.drawString("b", 7, 45);
		
		GradientPaint barColour = new GradientPaint(500, Y_OFFSET+RECT_SIDE, Color.RED, 520, 300, Color.BLUE);
		
		g2d.setPaint(barColour);
		
		g2d.fillRect(500, Y_OFFSET+RECT_SIDE, 20, 250);
		
		g2d.setColor(Color.BLACK);
		g2d.drawString((int)MAX_VALUE+"", 520, Y_OFFSET+RECT_SIDE+10);
		g2d.drawString("0", 520, 300);
	}

}
