package bicliqueviz;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartFrame;
import org.jfree.chart.JFreeChart;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.chart.plot.PlotOrientation;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.JComboBox;
import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class HistogramCommWin implements ActionListener
{
	static final long serialVersionUID = 748346l;
	private DefaultCategoryDataset data;
	private DefaultMutableTreeNode root;
	private JComboBox combo;
	private ChartFrame frame;

	public HistogramCommWin(DefaultMutableTreeNode r) 
	{
		root = r;
		createChart();
	}
	
	private void createChart()
	{		
		createCommList();
		data = createDataSet(0);
		
		JFreeChart chart = ChartFactory.createStackedBarChart("Community size histogram", "Community ID", 
				"Community size", data, PlotOrientation.VERTICAL, true, true, false);
		
		frame = new ChartFrame("Community size histogram", chart);
		frame.setLayout(new BorderLayout());
		frame.add(combo, BorderLayout.NORTH);
		frame.pack();
		frame.setVisible(true);
	}
	
	private void createCommList()
	{
		if(root != null)
		{
			String[] comms = new String[root.getChildCount()];
			
			for(int i = 0; i < root.getChildCount(); i++)
			{
				DefaultMutableTreeNode n = (DefaultMutableTreeNode)root.getChildAt(i);
				
				comms[i] = n.getUserObject().toString();
			}
			
			combo = new JComboBox(comms);
			combo.addActionListener(this);
		}
	}
	
	private DefaultCategoryDataset createDataSet(int index)
	{
		DefaultCategoryDataset d = new DefaultCategoryDataset();
		
		if(root != null)
		{	
			DefaultMutableTreeNode n = (DefaultMutableTreeNode)root.getChildAt(index);
			
			for(int j = 0; j < n.getChildCount(); j++)
			{
				DefaultMutableTreeNode nn = (DefaultMutableTreeNode)n.getChildAt(j);
				
				Community c = (Community)nn.getUserObject();
				
				d.addValue(c.getNumOfUpperNodes(), "Node A", c.getID()+"");
				d.addValue(c.getNumOfLowerNodes(), "Node B", c.getID()+"");
			}
		}
		
		return d;
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource().equals(combo))
		{
			data = createDataSet(combo.getSelectedIndex());
			JFreeChart chart = ChartFactory.createStackedBarChart("Community size histrogram", "Community ID", 
					"Community size", data, PlotOrientation.VERTICAL, true, true, false);
			frame.getChartPanel().setChart(chart);
		}
	}
}
