package bicliqueviz;

import java.awt.Cursor;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JProgressBar;
import java.awt.Dimension;
import java.awt.Toolkit;

/**
 * 
 * Window with progress bar
 * 
 * This class represents the progress bar window
 * 
 * @author Martin Schwartz
 *
 */
public class ProgWin extends JFrame
{
	private final static long serialVersionUID = 521;
	private JProgressBar bar;

	/**
	 * 
	 */
	public ProgWin() 
	{
		super("Progress");
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
		setAlwaysOnTop(true);
		setResizable(false);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		
		bar = new JProgressBar();
		bar.setStringPainted(true);
		bar.setValue(0);
		bar.setOpaque(true);
		
		setContentPane(bar);
		
		setSize(150, 80);
		setLocation((int)(screen.getWidth()/2.0)-this.getWidth()/2, 100);
		
		setTextAreaHeader("Loading");
		setVisible(false);
	}
	
	/**
	 * @param s new value for the progress bar
	 */
	public void setValue(int s)
	{
		bar.setValue(s);
		this.update(this.getGraphics());
	}
	
	/**
	 * @param name text for header
	 */
	public void setTextAreaHeader(String name)
	{
		bar.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEmptyBorder(),name));
		this.update(this.getGraphics());
	}
	
	/**
	 * @param b true=show window, false=hide window
	 */
	public void showWin(boolean b)
	{
		setVisible(b);
		this.update(this.getGraphics());
	}
}
