package bicliqueviz;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileWriter;

/**
 * 
 * Class for taking care of system call outputs
 * 
 * @author the1schwartz
 *
 */
public class StreamGobbler implements Runnable
{
	String name;
	InputStream is;
	Thread thread;
	
	/**
	 * @param name name of output file
	 * @param is pointer to the input stream
	 */
	public StreamGobbler (String name, InputStream is) 
	{
		this.name = name;
		this.is = is;
	}

	/**
	 * Start thread
	 */
	public void start () 
	{
		thread = new Thread (this);
		thread.start ();
	}
	
	public void run () 
	{
		try 
		{
			InputStreamReader isr = new InputStreamReader (is);
			BufferedReader br = new BufferedReader (isr);
			BufferedWriter writer = new BufferedWriter(new FileWriter(name));
	
			while (true) 
			{
				String s = br.readLine ();
				if (s == null)
				{
					break;
				}
				writer.write(s+"\n");
			}
			
			is.close ();
			writer.close();
		} 
		catch (Exception ex) 
		{
			System.out.println ("Problem reading stream " + name + "... :" + ex);
			ex.printStackTrace ();
		}
	}
}
