package bicliqueviz;

import org.apache.commons.collections15.Transformer;
import java.awt.Paint;
import java.awt.Color;
import edu.uci.ics.jung.visualization.picking.PickedInfo;

/**
 * 
 * Class for the vertex fill colour
 * 
 * @author the1schwartz
 *
 */
public class VertexFillColour implements Transformer<VertexObj,Paint>
{
	private PickedInfo<VertexObj> pi;
	private Color red = new Color(1f, 0, 0);
	private Color blue = new Color(0, 0, 1f);
	private Color yellow = new Color(1f, 1f, 0);

	/**
	 * @param pi pciked state of the graph
	 */
	public VertexFillColour(PickedInfo<VertexObj> pi) 
	{
		this.pi = pi;
	}
	
	public Paint transform(VertexObj v)
	{
		if(pi.isPicked(v))
		{
			return yellow;
		}
		else
		{
			if(v.isVertexA())
			{
				if(v.getColor() != null)
				{
					return v.getColor();
				}
				else
				{
					return red;
				}
			}
			else
			{
				if(v.getColor() != null)
				{
					return v.getColor();
				}
				else
				{
					return blue;
				}
			}
		}
	}

}
