package bicliqueviz;

import java.awt.Stroke;
import java.awt.BasicStroke;

import org.apache.commons.collections15.Transformer;

import edu.uci.ics.jung.visualization.picking.PickedInfo;

/**
 * 
 * Class for thickness of the edge of vertices
 * 
 * @author the1schwartz
 *
 */
public class VertexStroke implements Transformer<VertexObj,Stroke>
{
	private PickedInfo<VertexObj> pi;

	/**
	 * @param pi picked state of graph
	 */
	public VertexStroke(PickedInfo<VertexObj> pi) 
	{
		this.pi = pi;
	}

	public Stroke transform(VertexObj v)
	{
		if(pi.isPicked(v))
		{
			return new BasicStroke(2.0f);
		}
		else
		{
			return new BasicStroke(1.0f);
		}
	}
}
